searchData={"items":[{"type":"module","title":"Premailex","doc":"Documentation for Premailex.","ref":"Premailex.html"},{"type":"function","title":"Premailex.to_inline_css/2","doc":"Adds inline styles to an HTML string.","ref":"Premailex.html#to_inline_css/2"},{"type":"function","title":"Examples - Premailex.to_inline_css/2","doc":"iex> Premailex.to_inline_css(\"   p{background-color: #fff;}    Text   \")\n    \"   p{background-color: #fff;}    Text   \"","ref":"Premailex.html#to_inline_css/2-examples"},{"type":"function","title":"Premailex.to_text/1","doc":"Turns an HTML string into text.","ref":"Premailex.html#to_text/1"},{"type":"function","title":"Examples - Premailex.to_text/1","doc":"iex> Premailex.to_text(\"   p{background-color:#fff;}    Text   \")\n    \"Text\"","ref":"Premailex.html#to_text/1-examples"},{"type":"module","title":"Premailex.CSSParser","doc":"Module that handles CSS parsing with naive Regular Expression.","ref":"Premailex.CSSParser.html"},{"type":"function","title":"Premailex.CSSParser.merge/1","doc":"Merges CSS rules.","ref":"Premailex.CSSParser.html#merge/1"},{"type":"function","title":"Examples - Premailex.CSSParser.merge/1","doc":"iex> rule_sets = Premailex.CSSParser.parse(\"p {background-color: #fff !important; color: #000;} p {background-color: #000;}\")\n    iex> Premailex.CSSParser.merge(rule_sets)\n    [%{directive: \"background-color\", value: \"#fff !important\", important?: true, specificity: 1},\n     %{directive: \"color\", value: \"#000\", important?: false, specificity: 1}]","ref":"Premailex.CSSParser.html#merge/1-examples"},{"type":"function","title":"Premailex.CSSParser.parse/1","doc":"Parses a CSS string into a map.","ref":"Premailex.CSSParser.html#parse/1"},{"type":"function","title":"Examples - Premailex.CSSParser.parse/1","doc":"iex> Premailex.CSSParser.parse(\"body { background-color: #fff !important; color: red; }\")\n    [%{rules: [%{directive: \"background-color\", value: \"#fff !important\", important?: true},\n               %{directive: \"color\", value: \"red\", important?: false}],\n       selector: \"body\",\n       specificity: 1}]","ref":"Premailex.CSSParser.html#parse/1-examples"},{"type":"function","title":"Premailex.CSSParser.parse_rules/1","doc":"Parses a CSS rules string into a map.\n\nNote: `parse_rules/1` won't strip any CSS comments unlike `parse/1`.","ref":"Premailex.CSSParser.html#parse_rules/1"},{"type":"function","title":"Examples - Premailex.CSSParser.parse_rules/1","doc":"iex> Premailex.CSSParser.parse_rules(\"background-color: #fff; color: red;\")\n    [%{directive: \"background-color\", value: \"#fff\", important?: false},\n     %{directive: \"color\", value: \"red\", important?: false}]","ref":"Premailex.CSSParser.html#parse_rules/1-examples"},{"type":"type","title":"Premailex.CSSParser.rule/0","doc":"","ref":"Premailex.CSSParser.html#t:rule/0"},{"type":"type","title":"Premailex.CSSParser.rule_set/0","doc":"","ref":"Premailex.CSSParser.html#t:rule_set/0"},{"type":"function","title":"Premailex.CSSParser.to_string/1","doc":"Transforms CSS map or list into string.","ref":"Premailex.CSSParser.html#to_string/1"},{"type":"function","title":"Examples - Premailex.CSSParser.to_string/1","doc":"iex> Premailex.CSSParser.to_string([%{directive: \"background-color\", value: \"#fff\"}, %{directive: \"color\", value: \"#000\"}])\n    \"background-color: #fff; color: #000;\"\n\n    iex> Premailex.CSSParser.to_string(%{directive: \"background-color\", value: \"#fff\"})\n    \"background-color: #fff;\"","ref":"Premailex.CSSParser.html#to_string/1-examples"},{"type":"module","title":"Premailex.HTMLInlineStyles","doc":"Module that processes inline styling in HMTL.","ref":"Premailex.HTMLInlineStyles.html"},{"type":"function","title":"Premailex.HTMLInlineStyles.process/3","doc":"Processes an HTML string adding inline styles.\n\nOptions:\n  * `:css_selector` - the style tags to be processed for inline styling, defaults to `style,link[rel=\"stylesheet\"][href]`\n  * `:optimize` - list or atom option for optimizing the output. The following values can be used:\n    * `:none` - no optimization (default)\n    * `:all` - apply all optimization steps\n    * `:remove_style_tags` - Remove style tags (can be combined in a list)","ref":"Premailex.HTMLInlineStyles.html#process/3"},{"type":"behaviour","title":"Premailex.HTMLParser","doc":"Module that provide HTML parsing API using an underlying HTML parser library.","ref":"Premailex.HTMLParser.html"},{"type":"function","title":"Premailex.HTMLParser.all/2","doc":"Searches an HTML tree for the selector.","ref":"Premailex.HTMLParser.html#all/2"},{"type":"function","title":"Examples - Premailex.HTMLParser.all/2","doc":"iex> Premailex.HTMLParser.all({\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Title\"]}]}]}, \"h1\")\n    [{\"h1\", [], [\"Title\"]}]","ref":"Premailex.HTMLParser.html#all/2-examples"},{"type":"callback","title":"Premailex.HTMLParser.all/2","doc":"","ref":"Premailex.HTMLParser.html#c:all/2"},{"type":"function","title":"Premailex.HTMLParser.filter/2","doc":"Filters elements matching the selector from the HTML tree.","ref":"Premailex.HTMLParser.html#filter/2"},{"type":"function","title":"Examples - Premailex.HTMLParser.filter/2","doc":"iex> Premailex.HTMLParser.filter([{\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Title\"]}]}]}], \"h1\")\n    [{\"html\", [], [{\"head\", [], []}, {\"body\", [], []}]}]","ref":"Premailex.HTMLParser.html#filter/2-examples"},{"type":"callback","title":"Premailex.HTMLParser.filter/2","doc":"","ref":"Premailex.HTMLParser.html#c:filter/2"},{"type":"type","title":"Premailex.HTMLParser.html_tree/0","doc":"","ref":"Premailex.HTMLParser.html#t:html_tree/0"},{"type":"function","title":"Premailex.HTMLParser.parse/1","doc":"Parses a HTML string into an HTML tree.","ref":"Premailex.HTMLParser.html#parse/1"},{"type":"function","title":"Examples - Premailex.HTMLParser.parse/1","doc":"iex> Premailex.HTMLParser.parse(\"     Title   \")\n    {\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Title\"]}]}]}","ref":"Premailex.HTMLParser.html#parse/1-examples"},{"type":"callback","title":"Premailex.HTMLParser.parse/1","doc":"","ref":"Premailex.HTMLParser.html#c:parse/1"},{"type":"type","title":"Premailex.HTMLParser.selector/0","doc":"","ref":"Premailex.HTMLParser.html#t:selector/0"},{"type":"function","title":"Premailex.HTMLParser.text/1","doc":"Extracts text elements from the HTML tree.","ref":"Premailex.HTMLParser.html#text/1"},{"type":"function","title":"Examples - Premailex.HTMLParser.text/1","doc":"iex> Premailex.HTMLParser.text({\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Title\"]}]}]})\n    \"Title\"","ref":"Premailex.HTMLParser.html#text/1-examples"},{"type":"callback","title":"Premailex.HTMLParser.text/1","doc":"","ref":"Premailex.HTMLParser.html#c:text/1"},{"type":"function","title":"Premailex.HTMLParser.to_string/1","doc":"Turns an HTML tree into a string.","ref":"Premailex.HTMLParser.html#to_string/1"},{"type":"function","title":"Examples - Premailex.HTMLParser.to_string/1","doc":"iex> Premailex.HTMLParser.to_string({\"html\", [], [{\"head\", [], []}, {\"body\", [], [{\"h1\", [], [\"Title\"]}]}]})\n    \"     Title   \"","ref":"Premailex.HTMLParser.html#to_string/1-examples"},{"type":"callback","title":"Premailex.HTMLParser.to_string/1","doc":"","ref":"Premailex.HTMLParser.html#c:to_string/1"},{"type":"module","title":"Premailex.HTMLToPlainText","doc":"Module that converts HTML emails to plain text.","ref":"Premailex.HTMLToPlainText.html"},{"type":"function","title":"Premailex.HTMLToPlainText.process/1","doc":"Processes HTML string into a plain text string.","ref":"Premailex.HTMLToPlainText.html#process/1"},{"type":"function","title":"Examples - Premailex.HTMLToPlainText.process/1","doc":"iex> Premailex.HTMLToPlainText.process(\"    Test    \")\n    \"* Test\"","ref":"Premailex.HTMLToPlainText.html#process/1-examples"},{"type":"module","title":"Premailex.HTTPAdapter.Httpc","doc":"HTTP adapter module for making http requests with httpc.\n\nSSL support will automatically be enabled if the `:certifi` and\n`:ssl_verify_fun` libraries exists in your project.","ref":"Premailex.HTTPAdapter.Httpc.html"},{"type":"module","title":"Premailex.Util","doc":"Module that contains utility functions.","ref":"Premailex.Util.html"},{"type":"type","title":"Premailex.Util.html_tree/0","doc":"","ref":"Premailex.Util.html#t:html_tree/0"},{"type":"type","title":"Premailex.Util.needle/0","doc":"","ref":"Premailex.Util.html#t:needle/0"},{"type":"function","title":"Premailex.Util.traverse/3","doc":"Traverses tree searching for needle, and will call provided function on\nany occurances.\n\nIf the function returns `{:halt, any}`, traverse will stop, and result will\nbe `{:halt, html_tree}`.","ref":"Premailex.Util.html#traverse/3"},{"type":"function","title":"Examples - Premailex.Util.traverse/3","doc":"iex> Premailex.Util.traverse({\"div\", [], [{\"p\", [], [\"First paragraph\"]}, {\"p\", [], [\"Second paragraph\"]}]}, \"p\", fn {name, attrs, _children} -> {name, attrs, [\"Updated\"]} end)\n    {\"div\", [], [{\"p\", [], [\"Updated\"]}, {\"p\", [], [\"Updated\"]}]}\n\n    iex> Premailex.Util.traverse({\"div\", [], [{\"p\", [], [\"First paragraph\"]}, {\"p\", [], [\"Second paragraph\"]}]}, {\"p\", [], [\"Second paragraph\"]}, fn {name, attrs, _children} -> {name, attrs, [\"Updated\"]} end)\n    {\"div\", [], [{\"p\", [], [\"First paragraph\"]}, {\"p\", [], [\"Updated\"]}]}\n\n    iex> Premailex.Util.traverse({\"div\", [], [{:comment, \"This is a comment\"}, {\"p\", [], [\"Paragraph\"]}]}, :comment, fn {:comment, _comment} -> {:comment, \"Updated\"} end)\n    {\"div\", [], [{:comment, \"Updated\"}, {\"p\", [], [\"Paragraph\"]}]}","ref":"Premailex.Util.html#traverse/3-examples"},{"type":"function","title":"Premailex.Util.traverse_reduce/3","doc":"Traverse all trees in array searching for needle, and will call function with\nelement and number times needle has been found so far.","ref":"Premailex.Util.html#traverse_reduce/3"},{"type":"function","title":"Examples - Premailex.Util.traverse_reduce/3","doc":"iex> Premailex.Util.traverse_reduce([{\"p\", [], [\"First paragraph\"]}, {\"p\", [], [\"Second paragraph\"]}], \"p\", fn({name, attrs, _children}, acc) -> {name, attrs, [\"Updated \" <> to_string(acc)]} end)\n    {[{\"p\", [], [\"Updated 0\"]}, {\"p\", [], [\"Updated 1\"]}], 2}","ref":"Premailex.Util.html#traverse_reduce/3-examples"},{"type":"function","title":"Premailex.Util.traverse_until_first/3","doc":"Traverses tree until first match for needle.","ref":"Premailex.Util.html#traverse_until_first/3"},{"type":"function","title":"Examples - Premailex.Util.traverse_until_first/3","doc":"iex> Premailex.Util.traverse_until_first({\"div\", [], [{\"p\", [], [\"First paragraph\"]}, {\"p\", [], [\"Second paragraph\"]}]}, \"p\", fn {name, attrs, _children} -> {name, attrs, [\"Updated\"]} end)\n    {\"div\", [], [{\"p\", [], [\"Updated\"]}, {\"p\", [], [\"Second paragraph\"]}]}","ref":"Premailex.Util.html#traverse_until_first/3-examples"},{"type":"extras","title":"Premailex","doc":"# Premailex\n\n[![Github CI](https://github.com/danschultzer/premailex/workflows/CI/badge.svg)](https://github.com/danschultzer/premailex/actions?query=workflow%3ACI) [![hexdocs.pm](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/premailex) [![hex.pm](https://img.shields.io/hexpm/v/premailex.svg?style=flat)](https://hex.pm/packages/premailex) [![hex.pm downloads](https://img.shields.io/hexpm/dt/premailex.svg?style=flat)](https://hex.pm/packages/premailex)\n\nPreflight for your HTML emails. Adds inline styling, and converts HTML to plain text.","ref":"README.html"},{"type":"extras","title":"Features - Premailex","doc":"* Add inline CSS properties from ` `\n* Add inline CSS properties from external ` ` stylesheets\n* Transform HTML to plain text","ref":"README.html#features"},{"type":"extras","title":"Installation - Premailex","doc":"```elixir\ndef deps do\n  [\n    # ...\n    {:premailex, \"~> 0.3.20\"},\n\n    # Optional, but recommended for SSL validation with :httpc\n    {:certifi, \"~> 2.4\"},\n    {:ssl_verify_fun, \"~> 1.1\"},\n    # ...\n  ]\nend\n```\n\nRun `mix deps.get` to install it.","ref":"README.html#installation"},{"type":"extras","title":"Getting started - Premailex","doc":"Transform an HTML string to text:\n\n```elixir\nPremailex.to_text(html)\n```\n\nAdd inline styles based on styles defined in ` `:\n\n```elixir\nPremailex.to_inline_css(html)\n```","ref":"README.html#getting-started"},{"type":"extras","title":"Example with Swoosh - Premailex","doc":"```elixir\ndef welcome(user) do\n  new()\n  |> to({user.name, user.email})\n  |> from({\"Dr B Banner\", \"hulk.smash@example.com\"})\n  |> subject(\"Hello, Avengers!\")\n  |> render_body(\"welcome.html\", %{username: user.username})\n  |> premail()\nend\n\ndefp premail(email) do\n  html = Premailex.to_inline_css(email.html_body)\n  text = Premailex.to_text(email.html_body)\n\n  email\n  |> html_body(html)\n  |> text_body(text)\nend\n```","ref":"README.html#example-with-swoosh"},{"type":"extras","title":"Example with Bamboo - Premailex","doc":"```elixir\ndef welcome_email do\n  new_email\n  |> subject(\"Email subject\")\n  |> to(\"test@example.com\")\n  |> from(\"test@example.com\")\n  |> put_text_layout(false)\n  |> render(\"email.html\")\n  |> premail()\nend\n\ndefp premail(email) do\n  html = Premailex.to_inline_css(email.html_body)\n  text = Premailex.to_text(email.html_body)\n\n  email\n  |> html_body(html)\n  |> text_body(text)\nend\n```","ref":"README.html#example-with-bamboo"},{"type":"extras","title":"HTML parser - Premailex","doc":"By default, premailex uses [`Floki`](https://github.com/philss/floki) to parse HTML, but you can exchange it for any HTML parser you prefer. [`Meeseeks`](https://github.com/mischov/meeseeks) is supported with the [`Premailex.HTMLParser.Meeseeks`](/lib/premailex/html_parser/meeseeks.ex) module. To use it, add the following to `config.exs`:\n\n```elixir\nconfig :premailex, html_parser: Premailex.HTMLParser.Meeseeks\n```","ref":"README.html#html-parser"},{"type":"extras","title":"LICENSE - Premailex","doc":"(The MIT License)\n\nCopyright (c) 2017 Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"README.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"CHANGELOG.html"},{"type":"extras","title":"v0.3.20 (2025-01-20) - Changelog","doc":"* Require Elixir 1.13\n* `Premailex.CSSParser.parse/1` now ignores empty selectors","ref":"CHANGELOG.html#v0-3-20-2025-01-20"},{"type":"extras","title":"v0.3.19 (2023-11-19) - Changelog","doc":"* Ignore `@charset` CSS at-rule","ref":"CHANGELOG.html#v0-3-19-2023-11-19"},{"type":"extras","title":"v0.3.18 (2023-04-07) - Changelog","doc":"* Fixed bug in `Premailex.HTMLToPlainText.parse/3` with ` `, ` `, ` ` being excluded if the HTML element had any attributes","ref":"CHANGELOG.html#v0-3-18-2023-04-07"},{"type":"extras","title":"v0.3.17 (2023-02-21) - Changelog","doc":"* `Premailex.HTMLInlineStyles.process/3` now warns when styles can't be loaded from URL's\n* `Premailex.HTMLInlineStyles.process/1` now parses ` ` and ` ` elements\n* `Premailex.CSSParser.parse/1` now handles escaped commas\n* Require Elixir 1.11","ref":"CHANGELOG.html#v0-3-17-2023-02-21"},{"type":"extras","title":"v0.3.16 (2022-07-01) - Changelog","doc":"* `Premailex.CSSParser.to_string/1` now adds whitespace between inline style rules","ref":"CHANGELOG.html#v0-3-16-2022-07-01"},{"type":"extras","title":"v0.3.15 (2022-03-24) - Changelog","doc":"* Fixed invalid spec in `Premailex.Util.traverse/3`","ref":"CHANGELOG.html#v0-3-15-2022-03-24"},{"type":"extras","title":"v0.3.14 (2022-03-08) - Changelog","doc":"* Added horizontal rule parsing to `Premailex.HTMLToPlainText.process/1`\n* `Premailex.Util.traverse/3` no longer strips comments\n* `Premailex.HTMLInlineStyles.process/3` strips empty comments\n* `Premailex.HTMLInlineStyles.process/3` now applies styles to ` ` elements","ref":"CHANGELOG.html#v0-3-14-2022-03-08"},{"type":"extras","title":"v0.3.13 (2020-11-24) - Changelog","doc":"* Fixed spec and docs issues.","ref":"CHANGELOG.html#v0-3-13-2020-11-24"},{"type":"extras","title":"v0.3.12 (2020-10-18) - Changelog","doc":"* `Premailex.HTMLInlineStyles.process/3` now supports passing in CSS as an argument","ref":"CHANGELOG.html#v0-3-12-2020-10-18"},{"type":"extras","title":"v0.3.11 (2020-10-08) - Changelog","doc":"* Fixed bug where the inline styles where applied to more than the first match causing in some cases styles to be missing for subsequent parent elements\n* Relax floki requirement\n* Relax meeseeks requirement","ref":"CHANGELOG.html#v0-3-11-2020-10-08"},{"type":"extras","title":"v0.3.10 (2020-01-09) - Changelog","doc":"* Support floki up to `v0.24.x`","ref":"CHANGELOG.html#v0-3-10-2020-01-09"},{"type":"extras","title":"v0.3.9 (2019-10-06) - Changelog","doc":"* Ignore `@font-face` at-rule","ref":"CHANGELOG.html#v0-3-9-2019-10-06"},{"type":"extras","title":"v0.3.8 (2019-08-22) - Changelog","doc":"* Removed HTTPoison and use `:httpc` instead\n* Fixed bug where HTML with no style tags resulted in all existing inline styles being removed\n* Added `is_binary/1` guard to `Premailex.to_inline_css/2` and `Premailex.to_text/1`","ref":"CHANGELOG.html#v0-3-8-2019-08-22"},{"type":"extras","title":"v0.3.7 (2019-07-05) - Changelog","doc":"* Preserve downlevel-revealed conditional comments in `Premailex.Util.traverse/3`","ref":"CHANGELOG.html#v0-3-7-2019-07-05"},{"type":"extras","title":"v0.3.6 (2019-06-22) - Changelog","doc":"* Preserve conditional comments in `Premailex.Util.traverse/3` so they can show up in output from `Premailex.HTMLInlineStyles.process/2`","ref":"CHANGELOG.html#v0-3-6-2019-06-22"},{"type":"extras","title":"v0.3.5 (2019-03-21) - Changelog","doc":"* Accept ` ` with ` ` elements.","ref":"CHANGELOG.html#v0-3-5-2019-03-21"},{"type":"extras","title":"v0.3.4 - Changelog","doc":"* HTTP adapter for HTTPoison that handles redirects #31 #32 (thanks Przemyslaw Mroczek @Lackoftactics)","ref":"CHANGELOG.html#v0-3-4"},{"type":"extras","title":"v0.3.3 - Changelog","doc":"* Ignore `@media` queries  #28 #29","ref":"CHANGELOG.html#v0-3-3"},{"type":"extras","title":"v0.3.2 - Changelog","doc":"* Remove bypass for tests and make http adapter configurable #27\n* Test with updated dependencies #26","ref":"CHANGELOG.html#v0-3-2"},{"type":"extras","title":"v0.3.1 - Changelog","doc":"* Handle url values in CSS rules correctly #25","ref":"CHANGELOG.html#v0-3-1"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Meeseeks `v0.8.0` no longer supported #23\n* Ensure Elixir 1.7 support #22","ref":"CHANGELOG.html#v0-3-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}